# Plexus Example

Here is a basic example of how you can use Plexus for logging.

```dart
import 'package:plexus/plexus.dart';

class Foo with HasModule {
  void doo(String name) {
    print('Hello, $name!');
  }

  @override
  final UnmodifiableListView<String> package = const UnmodifiableListView(['plexus', 'example', 'foo']);
}

Future<void> main(List<String> arguments) async {
  final root = RootModule();
  await root.start(() {
    root.level = Level.FINEST;
    root.subscribe('__console__', consoleHandler);
    final foo = Foo();
    foo.doo();
    foo.log(Level.INFO, 'Message from outside foo');
  });
}
```

For a slightly more complex example, see the example folder.
